org.apache.bcel.generic

## Class RET

- java.lang.Object
- - org.apache.bcel.generic.Instruction
  - - org.apache.bcel.generic.RET

- All Implemented Interfaces:
    Cloneable, IndexedInstruction, TypedInstruction

      public class RET
      extends Instruction
      implements IndexedInstruction, TypedInstruction

  RET - Return from subroutine

      Stack: ... -> ...

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.generic.Instruction

      `length, opcode`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RET(int index)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Call corresponding visitor method(s).
    `void` | `dump(DataOutputStream out)` Dump instruction as byte code to stream out.
    `int` | `getIndex()`
    `Type` | `getType(ConstantPoolGen cp)`
    `protected void` | `initFromFile(ByteSequence bytes, boolean wide)` Read needed data (e.g.
    `void` | `setIndex(int n)` Set index of local variable containg the return address
    `String` | `toString(boolean verbose)` Long output format: <name of opcode> "["<opcode number>"]" "("<length of instruction>")"

    - ### Methods inherited from class org.apache.bcel.generic.Instruction

      `consumeStack, copy, equals, getComparator, getLength, getName, getOpcode, hashCode, isValidByte, isValidShort, produceStack, readInstruction, setComparator, toString, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### RET

          public RET(int index)

  - ### Method Detail

    - #### dump

          public void dump(DataOutputStream out)
                    throws IOException

      Dump instruction as byte code to stream out.
      Overrides:
        `dump` in class `Instruction`
      Parameters:
        `out` - Output stream
      Throws:
        `IOException`

    - #### initFromFile

          protected void initFromFile(ByteSequence bytes,
                                      boolean wide)
                               throws IOException

      Read needed data (e.g. index) from file.
      Overrides:
        `initFromFile` in class `Instruction`
      Parameters:
        `bytes` - byte sequence to read from
        `wide` - "wide" instruction flag
      Throws:
        `IOException` - may be thrown if the implementation needs to read data from the file

    - #### getIndex

          public final int getIndex()

      Specified by:
        `getIndex` in interface `IndexedInstruction`
      Returns:
        index of local variable containg the return address

    - #### setIndex

          public final void setIndex(int n)

      Set index of local variable containg the return address
      Specified by:
        `setIndex` in interface `IndexedInstruction`

    - #### toString

          public String toString(boolean verbose)

      Description copied from class: `Instruction`
      Long output format: <name of opcode> "["<opcode number>"]" "("<length of instruction>")"
      Overrides:
        `toString` in class `Instruction`
      Parameters:
        `verbose` - long/short format switch
      Returns:
        mnemonic for instruction

    - #### getType

          public Type getType(ConstantPoolGen cp)

      Specified by:
        `getType` in interface `TypedInstruction`
      Returns:
        return address type

    - #### accept

          public void accept(Visitor v)

      Call corresponding visitor method(s). The order is: Call visitor methods of implemented interfaces first, then call methods according to the class hierarchy in descending order, i.e., the most specific visitXXX() call comes last.
      Specified by:
        `accept` in class `Instruction`
      Parameters:
        `v` - Visitor object

Copyright © 2004–2020 The Apache Software Foundation. All rights reserved.